<template>
    <div class="flex-center-box-container">
        <div class="flex-center-box-box">
            <h1>Register</h1>
            <BForm>
                <BaseValidationInput
                    input-label="User"
                    :input-value="form.username"
                    input-name="registerUser"
                    inputType="text"
                    @update="form.username = $event"
                />
                <BaseValidationInput
                    input-label="Email"
                    :input-value="form.email"
                    input-name="registerEmail"
                    inputType="text"
                    @update="form.email = $event"
                />
                <BaseValidationInput
                    input-label="Password"
                    :input-value="form.password"
                    input-name="registerPassword"
                    inputType="password"
                    @update="form.password = $event"
                />
                <BButton type="button" variant="primary" class="full-width mt-4" @click.prevent="register()">
                    <BSpinner variant="light" v-show="isLoading"></BSpinner>
                    <span class="whiteText" v-show="!isLoading">register</span>
                </BButton>
            </BForm>
            <div class="mt-3">
                <span class="flex-center-box-other-text"> Already Registered? </span>
                <router-link to="/login">
                    <span class="flex-center-box-other-link pointer"> Login </span>
                </router-link>
            </div>
        </div>
    </div>
</template>

<script>
import BaseValidationInput from '@/components/Base/BaseValidationInput';

export default {
    name: 'AppRegister',
    components: {
        BaseValidationInput,
    },
    data() {
        return {
            form: {
                password: '',
                email: '',
                username: '',
            },
            isLoading: false,
        };
    },
    methods: {
        register() {
            this.$validator.validateAll().then(async (isOkeyValidation) => {
                if (isOkeyValidation) {
                    this.isLoading = true;
                    const response = await this.$root.axiosApiCall(
                        'Register Failed',
                        'post',
                        'users',
                        {},
                        {
                            user: this.form,
                        },
                    );
                    console.log('response', response);
                    if (response && response.status == '200') {
                        console.log('hereeee');
                        /* Success notification */
                        this.$root.makeToastNotification('success', 'Register success', 'You Registered successfully');
                        /* redirect to login */
                        this.$router.push('login');
                    }
                    this.isLoading = false;
                }
            });
        },
        validateState(ref) {
            if (this.veeFields[ref] && (this.veeFields[ref].dirty || this.veeFields[ref].validated)) {
                return !this.veeErrors.has(ref);
            }
            return null;
        },
    },
};
</script>

<style scoped lang="scss">
@import '../includes/styles/flex-center-box';
</style>
